This service will be undergoing maintenance at 00:00 UTC, 2017-10-23 It is expected to last about 30 minutes

Bug 680789

Summary: logrotate: Race condition by creation of new files after renaming the previous version if compression or copy creation requested (arbitrary system file integrity corruption)
Product: [Other] Security Response Reporter: Jan Lieskovsky <jlieskov>
Component: vulnerabilityAssignee: Red Hat Product Security <security-response-team>
Status: CLOSED NOTABUG QA Contact:
Severity: medium Docs Contact:
Priority: medium    
Version: unspecifiedCC: jkaluza, petr.uzel, tsmetana
Target Milestone: ---Keywords: Security
Target Release: ---   
Hardware: All   
OS: Linux   
Whiteboard: public=20110213,reported=20110213,source=debian,impact=moderate,cvss2=6.3/AV:L/AC:M/Au:N/C:N/I:C/A:C,rhel-4/logrotate=affected,rhel-5/logrotate=affected,rhel-6/logrotate=affected,fedora-all/logrotate=affected
Fixed In Version: Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of: Environment:
Last Closed: 2011-03-11 01:30:25 EST Type: ---
Regression: --- Mount Type: ---
Documentation: --- CRM:
Verified Versions: Category: ---
oVirt Team: --- RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
Attachments:
Description Flags
proposed patch none

Description Jan Lieskovsky 2011-02-27 14:17:28 EST
A race condition was found in the way the logrotate utility created
new files after renaming the previous version if compression or
creation of a copy was requested in the configuration file. If the
logrotate utility was run on a log file contained within an attacker
controllable directory, a local attacker could use this flaw to trick
the logrotate utility into replacing arbitrary system files (if
logrotate was run under privileged user account, root) with the copied
or compressed contents of a log file.
Comment 3 Jan Kaluža 2011-03-01 04:15:16 EST
Created attachment 481568 [details]
proposed patch

This is backported patch from Debian without unlink command which fixes this issue.
Comment 4 Jan Kaluža 2011-03-01 04:17:49 EST
Note that final patch can change, because this issue is tightly connected with other bugs, so there will be maybe one bigger patch which will cover more bugs.
Comment 7 Jan Lieskovsky 2011-03-03 05:15:05 EST
Further clarified details from Stefan Fritsch of Debian Security Team:
=======================================================================

There is a race between renaming

950 if (!debug && rename(oldName, newName)) {

a previous generation log file (say from "foo.1" to "foo.2") and
opening a file with the old name ("foo.1") for writing. The open for
write can happen both in copyTruncate() or in compressLogFile() at

302 outFile = createOutputFile(compressedName, O_RDWR | O_CREAT |
O_TRUNC, sb);

The fix would be to use O_EXCL.